// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from fadecandy_msgs:msg/LEDArray.idl
// generated code does not contain a copyright notice

#ifndef FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__TRAITS_HPP_
#define FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "fadecandy_msgs/msg/detail/led_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'strips'
#include "fadecandy_msgs/msg/detail/led_strip__traits.hpp"

namespace fadecandy_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LEDArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: strips
  {
    if (msg.strips.size() == 0) {
      out << "strips: []";
    } else {
      out << "strips: [";
      size_t pending_items = msg.strips.size();
      for (auto item : msg.strips) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LEDArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: strips
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.strips.size() == 0) {
      out << "strips: []\n";
    } else {
      out << "strips:\n";
      for (auto item : msg.strips) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LEDArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace fadecandy_msgs

namespace rosidl_generator_traits
{

[[deprecated("use fadecandy_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const fadecandy_msgs::msg::LEDArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  fadecandy_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use fadecandy_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const fadecandy_msgs::msg::LEDArray & msg)
{
  return fadecandy_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<fadecandy_msgs::msg::LEDArray>()
{
  return "fadecandy_msgs::msg::LEDArray";
}

template<>
inline const char * name<fadecandy_msgs::msg::LEDArray>()
{
  return "fadecandy_msgs/msg/LEDArray";
}

template<>
struct has_fixed_size<fadecandy_msgs::msg::LEDArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<fadecandy_msgs::msg::LEDArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<fadecandy_msgs::msg::LEDArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__TRAITS_HPP_
